<?php
/* Copyright (C) 2001-2005 Rodolphe Quiedeville <rodolphe@quiedeville.org>
 * Copyright (C) 2004-2015 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) 2005-2012 Regis Houssin        <regis.houssin@capnetworks.com>
 * Copyright (C) 2015      Jean-François Ferry	<jfefe@aternatik.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *	\file       htdocs/containermanagement/template/containermanagementindex.php
 *	\ingroup    containermanagement
 *	\brief      Home page of containermanagement top menu
 */

// Load Dolibarr environment
$res=0;
// Try main.inc.php into web root known defined into CONTEXT_DOCUMENT_ROOT (not always defined)
if (! $res && ! empty($_SERVER["CONTEXT_DOCUMENT_ROOT"])) $res=@include($_SERVER["CONTEXT_DOCUMENT_ROOT"]."/main.inc.php");
// Try main.inc.php into web root detected using web root calculated from SCRIPT_FILENAME
$tmp=empty($_SERVER['SCRIPT_FILENAME'])?'':$_SERVER['SCRIPT_FILENAME'];$tmp2=realpath(__FILE__); $i=strlen($tmp)-1; $j=strlen($tmp2)-1;
while($i > 0 && $j > 0 && isset($tmp[$i]) && isset($tmp2[$j]) && $tmp[$i]==$tmp2[$j]) { $i--; $j--; }
if (! $res && $i > 0 && file_exists(substr($tmp, 0, ($i+1))."/main.inc.php")) $res=@include(substr($tmp, 0, ($i+1))."/main.inc.php");
if (! $res && $i > 0 && file_exists(dirname(substr($tmp, 0, ($i+1)))."/main.inc.php")) $res=@include(dirname(substr($tmp, 0, ($i+1)))."/main.inc.php");
// Try main.inc.php using relative path
if (! $res && file_exists("../main.inc.php")) $res=@include("../main.inc.php");
if (! $res && file_exists("../../main.inc.php")) $res=@include("../../main.inc.php");
if (! $res && file_exists("../../../main.inc.php")) $res=@include("../../../main.inc.php");
if (! $res) die("Include of main fails");

require_once DOL_DOCUMENT_ROOT.'/core/class/html.formfile.class.php';
require_once __DIR__. '/lib/SimpleXLSX.php';

// Load translation files required by the page
$langs->loadLangs(array("containermanagement@containermanagement"));

$action=GETPOST('action', 'alpha');


// Securite acces client
if (! $user->rights->containermanagement->read) accessforbidden();
$socid=GETPOST('socid','int');
if (isset($user->societe_id) && $user->societe_id > 0)
{
	$action = '';
	$socid = $user->societe_id;
}

$form = new Form($db);
$formfile = new FormFile($db);

llxHeader("",$langs->trans("ContainerManagementImportation"));

print load_fiche_titre($langs->trans("ContainerManagementImportation"),'','containermanagement.png@containermanagement');


if(isset($_POST["submitconfiguration"])) {
    
    $sql = "UPDATE `llx_containermanagement_import` SET rowpackinglist=". GETPOST('rowpackinglist').", rowfirstdata=". GETPOST('rowfirstdata')
            .", columnpalette=". GETPOST('columnpalette').", columncolis=". GETPOST('columncolis').", columncommandeclient=". GETPOST('columncommandeclient')
            .", columncontenucolis=". GETPOST('columncontenucolis').", columncodecouleur=". GETPOST('columncodecouleur').", columnquantite=". GETPOST('columnquantite');

    $db->query($sql);

    print $langs->trans("ContainerManagementImportationParametersSaved");
    print '<br>';
    
}



$sql = "SELECT rowpackinglist, rowfirstdata, columnpalette, columncolis, columncommandeclient, columncontenucolis, columncodecouleur, columnquantite "
        . "FROM `llx_containermanagement_import`";

$resql = $db->query($sql);
if ($resql)
{
    $configdata = $db->fetch_object($resql);
}

/*
 * Actions
 */

// None


/*
 * View
 */



print '<style>';
print '#table {display: table;}';
print '.row {display: table-row;}';
print '.cell {display: table-cell;padding: 0px;padding-left: 20px;}';
print '</style>';

print '<form action="' . $_SERVER["PHP_SELF"] . '" method="post" enctype="multipart/form-data">';

print '<div id="table">';
    

    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("RowPackingList") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->rowpackinglist . '" name="rowpackinglist" class="flat" size="10">';
        print '</span>';
    print '</div>';
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("RowFirstData") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->rowfirstdata . '" name="rowfirstdata" class="flat" size="10">';
        print '</span>';
    print '</div>';
    
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("ColumnPalette") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->columnpalette . '" name="columnpalette" class="flat" size="10">';
        print '</span>';
    print '</div>';
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("ColumnColis") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->columncolis . '" name="columncolis" class="flat" size="10">';
        print '</span>';
    print '</div>';
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("ColumnCommandeClient") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->columncommandeclient . '" name="columncommandeclient" class="flat" size="10">';
        print '</span>';
    print '</div>';
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("ColumnContenuColis") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->columncontenucolis . '" name="columncontenucolis" class="flat" size="10">';
        print '</span>';
    print '</div>';
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("ColumnCodeCouleur") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->columncodecouleur . '" name="columncodecouleur" class="flat" size="10">';
        print '</span>';
    print '</div>';
    print '<div class="row">';
        print '<span class="cell">';
            print $langs->trans("ColumnQuantite") . ' ';
        print '</span>';
        print '<span class="cell">';
            print '<input type="text" value="' . $configdata->columnquantite . '" name="columnquantite" class="flat" size="10">';
        print '</span>';
    print '</div>';
print '</div>';




print '<br><br>';
print '<input type="submit" value="' . $langs->trans("SaveConfiguration") . '" name="submitconfiguration" class="button">';
print '<br><br>';

if (isset($_FILES['file'])) {
	
    if ( $xlsx = SimpleXLSX::parse( $_FILES['file']['tmp_name'] ) ) {

        if(isset($_POST["directimportation"])) 
        {
            dol_syslog("importation numéro palette et colis ");
            
            echo '<h2>'.$langs->trans("FileImportationStarting").'</h2>';

            $row=0;
            $lastnumcommandeclient = '';
            $lastrefproduit = '';
            $multiple = false;
            
            foreach ( $xlsx->rows() as $k => $r ) {

                $row++;
                
                if ($row == $configdata->rowpackinglist) {
                    $refcontainer = substr($r[ 0 ], -8);
                    $sql = 'SELECT rowid FROM '.MAIN_DB_PREFIX.'containermanagement_container';
                    $sql.= ' WHERE ref=\'' . $refcontainer . '\'';

                    $containerressql1 = $db->query($sql);
                    
                    $numrowscontainer = $db->num_rows($containerressql1);
 
                    if ($numrowscontainer == 0) {
                        $sql = 'INSERT INTO '.MAIN_DB_PREFIX.'containermanagement_container (ref, fk_user_creat) '
                                     . 'VALUES(\''.$refcontainer .'\',' .$user->id . ')';
                        $db->query($sql);
                    }
                    
                    $db->free($containerressql1);
                }

                    

                if ($row >= $configdata->rowfirstdata) {
                    
                    // Vérifier s'il s'agit d'un produit composé ou non
                    if (strpos($r[ $configdata->columncontenucolis - 1 ], 'Part of the kit Nr') !== false) {
                        $refproduit = substr($r[ $configdata->columncontenucolis - 1 ], strpos($r[ $configdata->columncontenucolis - 1 ], 'Part of the kit Nr') + 21 ,8);
                        if (! is_numeric($refproduit)) {
                            while ((! is_numeric($refproduit)) && (strlen($refproduit) > 0)) {
                                $refproduit = substr($refproduit, 0, -1);
                            }                        
                        }
                    } else {
                    
                        // Prendre uniquement la valeur numérique du champ puis la concaténer avec le code couleur pour obtenir le code produit
                        $refproduit = substr($r[ $configdata->columncontenucolis - 1 ], 0 ,5);
                        if (! is_numeric($refproduit)) {
                            while ((! is_numeric($refproduit)) && (strlen($refproduit) > 0)) {
                                $refproduit = substr($refproduit, 0, -1);
                            }

                        }
                        $refproduit = $refproduit . $r[ $configdata->columncodecouleur - 1 ];                            
                    }
                    
                    $productexists = $db->query('SELECT rowid FROM '.MAIN_DB_PREFIX.'product WHERE ref=\'' . $refproduit . '\'');                    
                    $numproductexists = $db->num_rows($productexists);                    
                    if ($numproductexists == 0) {
                        $db->free($productexists);
                        // Si le produit n'est pas dans la base on passe à la ligne suivante
                        continue;
                    }
                    
                    if (strpos($r[ $configdata->columnpalette - 1], 'Bulk parcel') !== false) {
                        $numpalette = 'NP';
                    } else {
                        $numpalette = $r[ $configdata->columnpalette - 1 ];
                    }  
                    
                    $listnumpalette[] = $numpalette;
                    if (count($listnumpalette) > 2 && $multiple == false) {
                        unset($listnumpalette[0]);
                        $tmparray = array_values($listnumpalette);
                        $listnumpalette = $tmparray;
                    }
                    
                    $numcolis = $r[ $configdata->columncolis - 1 ];
                    $listnumcolis[] = $numcolis;
                    if (count($listnumcolis) > 2 && $multiple == false) {
                        unset($listnumcolis[0]);
                        $tmparray = array_values($listnumcolis);
                        $listnumcolis = $tmparray;
                    }
                    
                    $numcommandeclient = $r[ $configdata->columncommandeclient - 1 ];
                    
                    $sql = 'SELECT rowid FROM '.MAIN_DB_PREFIX.'containermanagement_container';
                    $sql.= ' WHERE ref=\'' . $refcontainer . '\'';

                    $containerressql2 = $db->query($sql);
                    if ($db->num_rows($containerressql2) > 0) {
                        $containerobj = $db->fetch_object($containerressql2);
                        $containerrowid = $containerobj->rowid;
                    }
                    
                    $sql = 'SELECT rowid FROM '.MAIN_DB_PREFIX.'commande_fournisseur';
                    $sql.= ' WHERE ref=\'' . $numcommandeclient . '\'';
                    
                    $containerressql3 = $db->query($sql);
                    if ($db->num_rows($containerressql3) > 0) {
                        $commandefournobj = $db->fetch_object($containerressql3);
                        $commandefournrowid = $commandefournobj->rowid;
                    }  
                    
                    if (!empty($containerrowid) && !empty($commandefournrowid)) {
                        $sql = 'INSERT INTO '.MAIN_DB_PREFIX.'commande_fournisseur_extrafields (fk_id_container,fk_object) VALUES(\''. $containerrowid .'\','. $commandefournrowid 
                                .') ON DUPLICATE KEY UPDATE fk_id_container=\''. $containerrowid .'\'';
                        //$sql = 'UPDATE '.MAIN_DB_PREFIX.'commande_fournisseur_extrafields SET fk_id_container = \''. $containerrowid 
                        //   .'\' WHERE fk_object = '.$commandefournrowid;                    

                    $db->query($sql);
                    }
                    

                    $db->free($containerressql2);
                    $db->free($containerressql3);
                    
                    if ($lastnumcommandeclient == $numcommandeclient) {
                        $memecommande = true;                        
                    } else {
                        $memecommande = false;
                    }
                    $lastnumcommandeclient = $numcommandeclient;
                                        
                    
                    if ($lastrefproduit == $refproduit && $memecommande == true) {
                        $lastrefproduit = $refproduit;
                        $numpalette = implode(";\n", array_unique($listnumpalette));
                        $numcolis = implode(";\n", array_unique($listnumcolis));
                        $multiple = true;
                    } else {
                        if ($multiple) {
                            unset($listnumpalette);
                            unset($listnumcolis);
                            $multiple = false;
                        }
                        $lastrefproduit = $refproduit;
                    }
                    
                    $quantite = $r[ $configdata->columnquantite - 1 ];
                    
                    $sql = 'SELECT cde.fk_object, cd.rowid FROM '.MAIN_DB_PREFIX.'commande as c';
                    $sql.= ' LEFT JOIN '.MAIN_DB_PREFIX.'element_element as ee ON ee.fk_source = c.rowid AND ee.sourcetype=\'commande\' AND ee.targettype=\'order_supplier\'';
                    $sql.= ' LEFT JOIN '.MAIN_DB_PREFIX.'commande_fournisseur as cf ON ee.fk_target = cf.rowid AND ee.sourcetype=\'commande\' AND ee.targettype=\'order_supplier\'';
                    $sql.= ' LEFT JOIN '.MAIN_DB_PREFIX.'commandedet as cd ON c.rowid=cd.fk_commande';
                    $sql.= ' LEFT JOIN '.MAIN_DB_PREFIX.'product as pdct ON pdct.rowid=cd.fk_product';
                    $sql.= ' LEFT JOIN '.MAIN_DB_PREFIX.'commandedet_extrafields as cde ON cd.rowid = cde.fk_object';
                    $sql.= ' WHERE cf.ref=\'' . $numcommandeclient . '\' AND pdct.ref=\'' . $refproduit . '\'';

                    $orderresql = $db->query($sql);
                    dol_syslog("modification numéro palette et colis sql : " . $sql, LOG_DEBUG);

                    $numrows = $db->num_rows($orderresql);
                    dol_syslog("modification numéro palette et colis numrows: " . $numrows, LOG_DEBUG);



                    if ($numrows > 0) {
                        $pickobj = $db->fetch_object($orderresql);
                        $cdefkobject = $pickobj->fk_object;
                        $cdrowid = $pickobj->rowid;

                    }
                    if (empty($cdefkobject)) {
                        $requetesql = 'INSERT INTO '.MAIN_DB_PREFIX.'commandedet_extrafields (fk_object, numpalettecontainer, numcoliscontainer) '
                                     . 'VALUES('.$cdrowid.',\''. $numpalette .'\',\''. $numcolis .'\')';
                    } else {
                        $requetesql = 'UPDATE '.MAIN_DB_PREFIX.'commandedet_extrafields as cde SET cde.numpalettecontainer = \''. $numpalette 
                                     .'\',cde.numcoliscontainer = \''. $numcolis .'\' WHERE cde.fk_object = '.$cdefkobject;
                    }

                    $db->query($requetesql);

                    $db->free($orderresql);
                }
            }
            
            dol_syslog("modification numéro palette colis fin", LOG_DEBUG);
            echo '<h2>'.$langs->trans("FileImportationFinished").'</h2>';
            setEventMessage($langs->trans("FileImportationSuccessful"));

        } else {

            echo '<h2>'.$langs->trans("FileContents").'</h2>';
            echo '<table border="1" cellpadding="3" style="border-collapse: collapse">';
            list( $cols, ) = $xlsx->dimension();

            $row=0;
            foreach ( $xlsx->rows() as $k => $r ) {

                $row++;

                if ($row == $configdata->rowpackinglist) {

                    $refcontainer = substr($r[ 0 ], -8);
                    echo '<tr>';
                    echo '<td>Packing List : </td>';
                    echo '<td>' . ( isset( $refcontainer ) ? $refcontainer : '&nbsp;' ) . '</td>';
                    echo '</tr>';
                }

                if ($row == ($configdata->rowfirstdata - 1)) {
                    echo '<tr>';
                    echo '<td>N° Palette</td>';
                    echo '<td>N° Colis</td>';
                    echo '<td>N° Commande client</td>';
                    echo '<td>N° Produit</td>';
                    echo '<td>Quantité</td>';
                    echo '</tr>';
                }
                    
                if ($row >= $configdata->rowfirstdata) {
                    echo '<tr>';
                    
                    if (strpos($r[ $configdata->columnpalette - 1], 'Bulk parcel') !== false) {
                        $numpalette = 'NP';
                    } else {
                        $numpalette = $r[ $configdata->columnpalette - 1 ];
                    }                    
                    echo '<td>' . ( isset( $numpalette ) ? $numpalette : '&nbsp;' ) . '</td>';

                    $numcolis = $r[ $configdata->columncolis - 1 ];
                    echo '<td>' . ( isset( $numcolis ) ? $numcolis : '&nbsp;' ) . '</td>';

                    $numcommandeclient = $r[ $configdata->columncommandeclient - 1 ];
                    echo '<td>' . ( isset( $numcommandeclient ) ? $numcommandeclient : '&nbsp;' ) . '</td>';

                    // Vérifier s'il s'agit d'un produit composé ou non
                    if (strpos($r[ $configdata->columncontenucolis - 1 ], 'Part of the kit Nr') !== false) {
                        dol_syslog("produit composé détecté, débute au caractère : " . strpos($r[ $configdata->columncontenucolis - 1 ], 'Part of the kit Nr'), LOG_DEBUG);
                        $refproduit = substr($r[ $configdata->columncontenucolis - 1 ], strpos($r[ $configdata->columncontenucolis - 1 ], 'Part of the kit Nr') + 21 ,8);
                        if (! is_numeric($refproduit)) {
                            while ((! is_numeric($refproduit)) && (strlen($refproduit) > 0)) {
                                $refproduit = substr($refproduit, 0, -1);
                            }                        
                        }
                    } else {
                    
                        // Prendre uniquement la valeur numérique du champ puis la concaténer avec le code couleur pour obtenir le code produit
                        $refproduit = substr($r[ $configdata->columncontenucolis - 1 ], 0 ,5);
                        if (! is_numeric($refproduit)) {
                            while ((! is_numeric($refproduit)) && (strlen($refproduit) > 0)) {
                                $refproduit = substr($refproduit, 0, -1);
                            }

                        }
                        $refproduit = $refproduit . $r[ $configdata->columncodecouleur - 1 ];                            
                    }
                    
                    $productexists = $db->query('SELECT rowid FROM '.MAIN_DB_PREFIX.'product WHERE ref=\'' . $refproduit . '\'');                    
                    $numproductexists = $db->num_rows($productexists);                    
                    if ($numproductexists == 0) {
                        $refproduit .= ' #UNKNOWN';
                    }
                    
                    echo '<td>' . ( isset( $refproduit ) ? $refproduit : '&nbsp;' ) . '</td>';

                    $quantite = $r[ $configdata->columnquantite - 1 ];
                    echo '<td>' . ( isset( $quantite ) ? $quantite : '&nbsp;' ) . '</td>';

                    echo '</tr>';
                }

            }
            echo '</table>';
            print '<br><br>';

        }


    } else {
	echo SimpleXLSX::parseError();
    }
}
print '</form>';

echo '<h2><u>' . $langs->trans("UploadForm") . '</u></h2>
<form method="post" enctype="multipart/form-data">
*.XLSX <input type="file" name="file"  />&nbsp;&nbsp;<input type="submit" value="' . $langs->trans("SubmitFileTest") . '" class="button"/>
<input type="submit" value="' . $langs->trans("DirectImportation") . '" name="directimportation" class="button"/>
</form>';

llxFooter();

$db->close();
